000010 @OPTIONS MAIN,TEST
000020 Identification Division.
000030 Program-Id.  Cutenum.
000040* By Thane Hubbell - 01/15/1999 
000041* Compiled and Tested under Fujitsu COBOL
000042 Environment Division.
000050 Configuration Section.
000060 Source-Computer.  IBM-PC.
000070 Object-Computer.  IBM-PC.
000080 Data Division.
000090 Working-Storage Section.
000252 01  The-Number            Pic 9(9) Value Zeros.
000254 01  Text-Field            Pic X(200) Value Spaces.
000255 01  Number-Descriptions.
000256     03  Table-Area-Low.
000257         05  Filler Pic X(8) Value "One".
000258         05  Filler Pic X(8) Value "Two".
000259         05  Filler Pic X(8) Value "Three".
000260         05  Filler Pic X(8) Value "Four".
000261         05  Filler Pic X(8) Value "Five".
000262         05  Filler Pic X(8) Value "Six".
000263         05  Filler Pic X(8) Value "Seven".
000264         05  Filler Pic X(8) Value "Eight".
000265         05  Filler Pic X(8) Value "Nine".
000266         05  Filler Pic X(8) Value "Ten".
000267         05  Filler Pic X(8) Value "Eleven".
000268         05  Filler Pic X(8) Value "Twelve".
000269         05  Filler Pic X(8) Value "Thirteen".
000270     03  Low-Numbers Redefines Table-Area-Low.
000271         05  Low-Number Pic X(8) Occurs 13 Times.
000272     03  Table-Area-Secondary.
000273         05  Filler Pic X(7) Value Spaces.
000274         05  Filler Pic X(7) Value "Twenty".
000275         05  Filler Pic X(7) Value "Thirty".
000276         05  Filler Pic X(7) Value "Fourty". 
000277         05  Filler Pic X(7) Value "Fifty".
000278         05  Filler Pic X(7) Value "Sixty".
000279         05  Filler Pic X(7) Value "Seventy".
000280         05  Filler Pic X(7) Value "Eighty".
000281         05  Filler Pic X(7) Value "Ninety".
000282     03  Secondary-Numbers Redefines Table-Area-Secondary.
000283         05  Secondary-Number Pic X(7) Occurs 9 Times.
000284     03  Table-Area-Ante.
000285         05  Filler Pic X(8) Value Spaces.
000286         05  Filler Pic X(8) Value "Million".
000287         05  Filler Pic X(8) Value Spaces.
000288         05  Filler Pic X(8) Value "Thousand".
000289         05  Filler Pic X(8) Value Spaces.
000290         05  Filler Pic X(8) Value Spaces.
000292     03  Ante-Numbers Redefines Table-Area-Ante.
000293         05  Ante-Number Pic X(8) Occurs 6 Times.
000294 01  Cntr Pic 99 Value Zeros.
000295 01  String-Pointer Pic 99 Value 1.
000296 01  Digits Pic 9 Value Zeros.
000297 01  Offset Pic 9 Value Zeros.
000298 01  Offset-Value Pic 9v9 Value Zeros.
000299 01  Test-Num Pic 99 Value Zeros.
000300 01  Second-Num Pic 99 Value Zeros.
000301 01  Ante-Flag Pic X Value Spaces.
000302     88 Print-Ante Value "Y".
000303     88 No-Print-Ante Value Spaces.
000304 Screen Section.
000305 01  Main-Screen
000306     Blank Screen, Auto, Required,
000307     Foreground-Color Is 7,
000308     Background-Color Is 1.
000309     03  Line 1 Column 1  Value "Enter Amount".
000310     03  Line 3 Column 1  Value "Result ".
000311     03  Line 1 Column 14 Pic 9(9) Using The-Number.
000312     03  Line 4 Column 1  Pic X(80) From Text-Field.
000313 Procedure Division.
000314 Cutenum-Start.
000315     Display Main-Screen
000316     Accept Main-Screen
000324     Perform Varying Cntr From 1 By 1 Until Cntr > 6
000325       If Digits = 2
000326          Subtract 1 From Digits
000327       Else
000328          Add 1 To Digits
000329       End-If
000330       Move Offset-Value to Offset
000331       Add .5 to Offset-Value
000332       Compute Test-Num = 
000334        Function Numval (The-Number (Cntr + Offset:Digits))
000335       Evaluate Digits Also Test-Num
000338          When 1 Also 1 Thru 9
000339            String Low-Number (Test-Num)
000340              Delimited By Space 
000341              " Hundred " Delimited By Size
000342              Into Text-Field
000343              Pointer String-Pointer
000344            Set Print-Ante To True
000345          When 2 Also 1 Thru 9
000346            String Low-Number (Test-Num)
000347              Delimited by Space
000348              Space Delimited by Size
000349              Into Text-Field
000350              Pointer String-Pointer
000351            Set Print-Ante To True
000352          When 2 Also 10 Thru 13
000353            String Low-Number (Test-Num)
000354              Delimited By Space
000355              Space Delimited By Size
000356              Into Text-Field
000357              Pointer String-Pointer
000358            Set Print-Ante To True
000359          When 2 Also 14 Thru 19
000360              Compute Second-Num = 
000361                 Function Rem (Test-Num 10)
000362              String Low-Number (Second-Num)
000363                 "teen" Delimited By Space
000364                 Space Delimited by Size
000365                 Into Text-Field
000366                 Pointer String-Pointer
000367              Set Print-Ante To True
000368          When 2 Also 20 Thru 99     
000369              Move Test-Num To Second-Num
000370              Move "0" To Second-Num (2:1)
000371              Subtract Second-Num From Test-Num
000372              Divide Second-Num By 10 Giving Second-Num
000373              String Secondary-Number (Second-Num)
000374                 Low-Number (Test-Num)
000375                 Delimited By Space
000376                 Space Delimited By Size
000377                 Into Text-Field
000378                 Pointer String-Pointer
000379              Set Print-Ante To True
000380       End-Evaluate
000381       If Digits = 2 And Print-Ante
000382        String Ante-Number (Cntr)
000383         Delimited By Space
000384         Space Delimited By Size
000385         Into Text-Field
000386         Pointer String-Pointer 
000387        Set No-Print-Ante To True
000388       End-if   
000389     End-Perform
000390     Display Main-Screen
000391     Display Text-Field Upon Console
000460     Stop Run.
